<?php

namespace controller;

use lib\base\BaseController;
use lib\Db;
use lib\help\Json;
use models\StoreProduct;
use models\StoreProductDescription;
use models\User;
use models\Diy;
use models\StoreProductCate;

class IndexController extends BaseController
{

    protected function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
    }

    public function index()
    {
        $this->assign([
            'version' => $this->request->version(),
            'isUpgrade' => $this->request->isUpgrade() ? false : true,
            'next' => 1,
            'action' => 'upgrade'
        ]);
        return $this->fetch();
    }

    public function upgrade()
    {
        [$sleep, $prefix, $alone] = $this->request->getData([
            ['sleep', 0],
            ['prefix', 'eb_'],
            ['alone', 0]
        ], null, true);
        $upgradeData = $this->request->getUpgradeData();
        if ($alone == 0) {
            if ($this->request->isUpgrade() || $this->request->setIsUpgrade('nextaA1')) {
                return Json::success('执行完毕', ['sleep' => -1]);
            }
            if (!isset($upgradeData[$sleep]) || count($upgradeData) < $sleep) {
                $this->request->setIsUpgrade('nextaA1', 1);
                return Json::success('执行完毕', ['sleep' => -1]);
            }
        }
        foreach ($upgradeData as $key => $item) {
            if ($key == (int)$sleep) {
                Db::beginTrans();
                try {
                    switch ($item['type']) {
                        case 1:
                        case -1:
                        case -2:
                        case -3:
                            $item['sql'] = $this->replace($item['sql'], $prefix);
                            $res = Db::querySql($item['sql'], true);
                            $item['status'] = 1;
                            $item['error'] = '执行成功';
                            $item['sleep'] = $key + 1;
                            $item['add_time'] = date('Y-m-d H:i:s', time());
                            Db::commit();
                            return Json::success('执行成功', $item);
                            break;
                        case 2:
                            if (Db::table($this->replace($item['table'], $prefix))->isTabel()) {
                                $item['status'] = 1;
                                $item['error'] = $item['table'] . '表已存在';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            } else {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                                $item['status'] = 1;
                                $item['error'] = '执行成功';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 3:
                            if ($item['where'] && $item['field']) {
                                $field = $item['field'];
                                $sql = $item['where'];
                                $id = (int)$sql;
                                if ($id === 0) {
                                    $id = Db::queryFind($this->replace($sql, $prefix), $field);
                                }
                                if ($id) {
                                    $item['sql'] = $this->replace($item['sql'], $prefix);
                                    $item['sql'] = $this->replace($item['sql'], $id, '@' . $field);
                                    $res = Db::querySql($item['sql'], true);
                                } else {
                                    $res = true;
                                }
                            } else {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                            }
                            if ($res) {
                                Db::commit();
                                $item['status'] = 1;
                                $item['error'] = '无错误';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 4:
                            if (Db::table($this->replace($item['table'], $prefix))->be($item['field'])) {
                                $item['status'] = 1;
                                $item['error'] = $item['table'] . '表的' . $item['field'] . '字段已存在';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            } else {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                                $item['status'] = 1;
                                $item['error'] = '执行成功';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 5:
                            if ($item['field'] && method_exists($this, $item['field'])) {
                                $res = $this->{$item['field']}($prefix);
                                if ($res) {
                                    $item['status'] = 1;
                                    $item['error'] = '执行成功';
                                    $item['sleep'] = $key + 1;
                                    return Json::success('执行成功', $item);
                                } else {
                                    $item['status'] = 1;
                                    $item['error'] = '执行失败';
                                    $item['sleep'] = $key + 1;
                                    return Json::success('执行失败', $item);
                                }
                            } else {
                                $item['status'] = 1;
                                $item['error'] = '执行成功';
                                $item['sleep'] = $key + 1;
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 6:
                            $sql = $this->replace($item['where'], $prefix);
                            if ($item['where']) {
                                if (!Db::queryFind($this->replace($item['where'], $prefix), $item['field'])) {
                                    $item['sql'] = $this->replace($item['sql'], $prefix);
                                    $res = Db::querySql($item['sql'], true);
                                }
                            }
                            $item['status'] = 1;
                            $item['error'] = '执行成功';
                            $item['sleep'] = $key + 1;
                            $item['add_time'] = date('Y-m-d H:i:s', time());
                            Db::commit();
                            return Json::success('执行成功', $item);
                            break;
                        case 7:
                            if (Db::table($this->replace($item['table'], $prefix))->be($item['field'])) {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                                $item['status'] = 1;
                                $item['error'] = '更新字段数据成功';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            } else {
                                $item['status'] = 1;
                                $item['error'] = $item['table'] . '表的' . $item['field'] . '字段不存在';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 8:
                            if (Db::table($this->replace($item['table'], $prefix))->where($item['key'], $item['field'])->find()) {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                            } else {
                                $item['status'] = 1;
                                $item['error'] = $item['field'] . "数据不存在";
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                Db::commit();
                                return Json::success('执行成功', $item);
                            }
                            if ($res) {
                                Db::commit();
                                $item['status'] = 1;
                                $item['error'] = '无错误';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 9:
                            if (isset($item['insert_where']) && $item['insert_where']) {
                                $where_sql = $item['insert_where'];
                                if ((int)$where_sql === 0) {
                                    if (!Db::querySql($this->replace($where_sql, $prefix))) {
                                        $item['sql'] = $this->replace($item['sql'], $prefix);
                                        if ($item['where'] && $item['field']) {
                                            $field = $item['field'];
                                            $sql = $item['where'];
                                            $id = (int)$sql;
                                            if ($id === 0) {
                                                $id = Db::queryFind($this->replace($sql, $prefix), $field);
                                            }
                                            $item['sql'] = $this->replace($item['sql'], $id, '@' . $field);
                                        }
                                        $res = Db::querySql($item['sql'], true);
                                    } else {
                                        $res = true;
                                    }
                                }
                            } else {
                                $item['sql'] = $this->replace($item['sql'], $prefix);
                                $res = Db::querySql($item['sql'], true);
                            }
                            if ($res) {
                                Db::commit();
                                $item['status'] = 1;
                                $item['error'] = '无错误';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                return Json::success('执行成功', $item);
                            }
                            break;
                        case 10:
                            $value = $item['data'] ?? [];
                            $value = json_encode($value);
                            $field = $item['field'] ?? '';
                            $item['sql'] = $this->replace($item['sql'], $prefix);
                            $item['sql'] = $this->replace($item['sql'], $value, '@' . $field);
                            $res = Db::querySql($item['sql'], true);
                            if ($res) {
                                Db::commit();
                                $item['status'] = 1;
                                $item['error'] = '无错误';
                                $item['sleep'] = $key + 1;
                                $item['add_time'] = date('Y-m-d H:i:s', time());
                                return Json::success('执行成功', $item);
                            }
                    }
                } catch (\Throwable $e) {
                    $item['status'] = 0;
                    $item['sleep'] = $key + 1;
                    $item['add_time'] = date('Y-m-d H:i:s', time());
                    $item['error'] = $e->getMessage();
                    Db::rollBack();
                    return Json::success('执行失败', $item);
                }
            }
        }
        return Json::fail('执行失败');
    }

    /**
     *
     * @param string $content
     * @param string $replace
     * @return mixed
     */
    protected function replace(string $content, string $replace, $search = 'eb_')
    {
        return str_replace($search, $replace, $content);
    }














}
