<?php

namespace lib;

use lib\help\Config;

class App
{

    /**
     *
     * @var \lib\Request
     */
    protected $request;

    /**
     * @var array
     */
    protected static $loadprintClass = [];

    public function __construct()
    {
    }

    protected function autoload()
    {
        spl_autoload_register([static::class, 'loadprint']);
    }

    public function run()
    {
        $this->autoload();
        $this->request = Request::instance();
        return $this;
    }

    /**
     * 执行http响应
     * @param string $controller
     * @return mixed
     */
    public function http(string $controller = '')
    {
        $controller = $controller ? $controller : $this->request->controller();
        if (!$controller) {
            $controller = Config::get('defaultController');
        }
        $action = $this->request->action();
        if (!$action) {
            $action = Config::get('defaultAction', 'index');
        }
        $controllerFile = str_replace('\\', '/', RUN_DIR . '/controller/' . ucfirst($controller) . 'Controller.php');
        $controllerClass = '\\controller\\' . ucfirst($controller) . 'Controller';
        if (is_file($controllerFile)) {
            include $controllerFile;
            if (class_exists($controllerClass)) {
                $controllerDrivers = new $controllerClass();
                if (method_exists($controllerDrivers, $action)) {
                    return $controllerDrivers->{$action}();
                } else {
                    throw new \RuntimeException('访问得方法' . $action . '不存在');
                }
            }
        }
        throw new \RuntimeException('访问得控制器' . $controllerClass . '不存在');
    }

    /**
     * 自动加载
     * @param $class
     */
    public static function loadprint($class)
    {
        $dir = str_replace('\\', '/', RUN_DIR . '/' . $class . '.php');
        array_push(self::$loadprintClass, $dir);
        if (is_file($dir)) {
            include $dir;
        }
    }
}