<?php

namespace lib;


use lib\help\Str;

class View
{

    /**
     * 默认地址
     * @var string
     */
    protected $videDir;

    protected $data = [];

    /**
     * @var string
     */
    protected $prefix = '.php';

    public function __construct()
    {
        $this->videDir = RUN_DIR . '/view';
    }

    /**
     * @param string|array $field
     * @param null $value
     * @return $this
     */
    public function assign($field, $value = null)
    {

        if (is_array($field)) {
            $this->data = array_merge($this->data, $field);
        } else {
            $this->data[$field] = $value;
        }
        return $this;
    }

    /**
     * 加载模板
     * @param string $template
     * @param array $data
     * @param string $prefix
     */
    public function fetch(string $template = '', array $data = [], string $prefix = '')
    {
        if (!$template) {
            $controller = Request::instance()->controller();
            $action = Request::instance()->action();
            $template = Str::studly($controller . '/' . $action);
        }
        if (count($data)) {
            $this->data = array_merge($this->data, $data);
        }
        extract($this->data, EXTR_OVERWRITE);
        $this->data = [];
        $template = strtolower($this->videDir . '/' . $template . ($prefix ? $prefix : $this->prefix));
        if (!is_file($template)) {
            throw new \RuntimeException('模板不存在:' . $template);
        }
        include $template;
    }
}