<?php

namespace lib\base;

use lib\Request;
use lib\View;

class BaseController
{
    /**
     * @var View
     */
    protected $view;

    /**
     * @var Request
     */
    protected $request;

    public function __construct()
    {
        $this->view = new View();
        $this->request = Request::instance();
        $this->initialize();
    }

    protected function initialize()
    {

    }

    /**
     * 设置变量
     * @param $assign
     * @param null $value
     * @return $this
     */
    protected function assign($assign, $value = null)
    {
        return $this->view->assign($assign, $value);
    }

    /**
     * @param string $template
     * @param array $data
     */
    protected function fetch(string $template = '', array $data = [])
    {
        return $this->view->fetch($template, $data);
    }
}