<?php

namespace lib\base;

use lib\Db;
use lib\help\Str;

/**
 * Class BaseModel
 * @package lib\base
 * @mixin Db
 */
abstract class BaseModel
{

    /**
     * name
     * @var string
     */
    protected static $name = '';

    /**
     * @var Db
     */
    protected static $db = [];


    /**
     * @return Db
     */
    protected static function getTbaleName()
    {
        $className = get_called_class();
        $className = explode('\\', $className);
        $name = strtolower(preg_replace('/(?<=[a-z])([A-Z])/', '_$1', $className[count($className) - 1] ?? ''));
        if (!isset(self::$db[$name])) {
            self::$db[$name] = Db::name(self::$name ?: $name);
        }
        return self::$db[$name];
    }

    /**
     * @param $name
     * @param $arguments
     * @return mixed
     */
    public static function __callStatic($name, $arguments)
    {
        return self::getTbaleName()->{$name}(...$arguments);
    }

    /**
     * 开启事务
     * @return bool
     */
    public static function beginTrans()
    {
        return Db::beginTrans();
    }

    /**
     * 提交事务
     * @return bool
     */
    public static function commit()
    {
        return Db::commit();
    }

    /**
     * 回滚事务
     * @return bool
     */
    public static function rollBack()
    {
        return Db::rollBack();
    }

}