<?php

namespace lib\help;

class Arr
{

    public static function setArrayValue(array $value, $name, $data)
    {

    }

    /**
     * @param array $value
     * @param $name
     * @param $default
     * @return array|mixed
     */
    public static function getArrayValue(array $value, $name, $default, bool $suffix = false)
    {
        $data = [];
        $i = 0;
        if (is_array($name)) {
            foreach ($name as $val) {
                if (is_array($val)) {
                    $k = $val[0] ?? '';
                    $v = $val[1] ?? '';
                    $data[$suffix ? $i++ : $k] = isset($value[$k]) && $value[$k] !== '' ? $value[$k] : $v;
                    unset($k, $v);
                } else {
                    if (isset($value[$val]) && $value[$val] !== '') {
                        $data[$suffix ? $i++ : $val] = $value[$val];
                    } else {
                        $data[$suffix ? $i++ : $val] = $default;
                    }
                }
            }
            return $data;
        } else {
            if (!$name) {
                return $default;
            }
            if (strstr($name, '.')) {
                [$key, $key1] = explode('.', $name);
                return $value[$key][$key1] ?? $default;
            } else {
                if (isset($value[$name]) && $value[$name] !== '') {
                    return $value[$name];
                } else {
                    return $default;
                }
            }
        }
    }

    /**
     * 组装数组
     * @param array|string $data
     * @param string $prefix
     * @param string $interval
     * @return string
     */
    public static function packageArry($data, string $prefix = '=', string $interval = ',')
    {
        if (is_string($data)) {
            return $data;
        }
        $string = '';
        $count = count($data);
        $i = 0;
        foreach ($data as $key => $val) {
            $i++;
            if ($count != $i) {
                $string .= "`" . $key . "`" . $prefix . "'" . $val . "'" . $interval;
            } else {
                $string .= "`" . $key . "`" . $prefix . "'" . $val . "'";
            }
        }
        return $string;
    }

    /**
     * @param array|string $data
     * @param string $prefix
     * @return bool|string
     */
    public static function fieldArray($data, string $prefix = ',', string $l = '')
    {
        if (is_string($data)) {
            return $data;
        }
        $string = '';
        $count = count($data);
        $i = 0;
        foreach ($data as $key => $val) {
            $i++;
            if ($count != $i) {
                $string .= $l . $val . $l . $prefix;
            } else {
                $string .= $l . $val . $l;
            }
        }
        return $string;
    }
}