<?php

namespace lib\help;

use lib\trail\Instance;

class Config
{
    use Instance;

    protected static $configData = [];

    protected function getConfigData()
    {
        if (self::$configData) {
            return self::$configData;
        }
        $files = glob(RUN_DIR . '/lib/config/*.php');
        $data = [];
        if (is_array($files)) {
            foreach ($files as $file) {
                if (is_file($file)) {
                    $value = include $file;
                    if (is_array($value)) {
                        $data = array_merge($data, $value);
                    }
                }
            }
        }
        return self::$configData = $data;
    }

    public static function get($vale, $default = null)
    {
        return Arr::getArrayValue(self::instance()->getConfigData(), $vale, $default);
    }

    public static function set()
    {

    }
}