<?php

namespace lib\help;

use lib\help\Arr;

/**
 * Class Env
 * @package lib\help
 */
class Env
{
    protected static $env;

    public static function init()
    {
        if (self::$env) {
            return self::$env;
        }
        return self::$env = parse_ini_file(CRMEB_DIR . '/.env', true);
    }

    /**
     * 获取配置
     * @param string|null $name
     * @param null $default
     * @return |null
     */
    public static function get(string $name = null, $default = null)
    {
        return Arr::getArrayValue(self::init(), strtoupper($name), $default);
    }
}