<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <link href="https://www.layuicdn.com/layui-v2.5.6/css/layui.css" rel="stylesheet">
    <script src="https://www.layuicdn.com/layui/layui.js"></script>
    <script src="https://cdn.bootcss.com/vue/2.6.11/vue.min.js"></script>
    <script src="https://cdn.bootcss.com/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdn.bootcss.com/axios/0.19.2/axios.min.js"></script>
    <style>
        body {
            background-color: #f3f3f4;
            margin-top: 10px;
        }

        .centered {
            text-align: center;
        }

        .centered button {
            width: 200px;
            height: 60px;
        }

        ;
    </style>
</head>
<body>
<div class="layui-fluid">
    <div class="layui-row layui-col-space15" id="app" v-cloak="">
        <div class="layui-card">
            <div class="centered">
                <div class="layui-progress">
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="12%" v-if="nextA == 1"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="25%" v-else-if="nextA == 2"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="37%" v-else-if="nextA == 3"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="50%" v-else-if="nextA == 4"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="62%" v-else-if="nextA == 5"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="75%" v-else-if="nextA == 6"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="87%" v-else-if="nextA == 7"></div>
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="100%" v-else-if="nextA == 8"></div>
                </div>
            </div>
            <div class="layui-card-header">升级系统</div>
            <div class="layui-card-body">
                <div class="layui-row">
                    <p style="font-size: 18px;">当前版本号: <span style="color: red">{{version}}</span></p>
                    <div class="layui-form-item" style="margin-top: 10px">
                        <label class="layui-form-label" style="font-size: 18px;padding-left: 0;">表前缀</label>
                        <div class="layui-input-block">
                            <input type="text" style="width: 10%" v-model="prefix" name="title" lay-verify="title"
                                   autocomplete="off" placeholder="请输入表前缀" class="layui-input">
                        </div>
                    </div>
                </div>
                <div class="centered">
                    <button type="button" class="layui-btn layui-btn-normal layui-btn-radius" v-if="isUpgrade && executeIng">
                        正在升级中
                    </button>
                    <button type="button" class="layui-btn layui-btn-normal layui-btn-radius" v-if="isUpgrade && executeIng == false"
                            @click="startUpgrade">立即升级
                    </button>
                    <button type="button" class="layui-btn layui-btn-normal layui-btn-radius" v-if="nextAction && executeIng == false"
                            @click="next">{{nextA == 3 && sleep == -1 ? '无需升级':'升级完成'}}
                    </button>
                    <button type="button" class="layui-btn layui-btn-normal layui-btn-radius" v-else-if="isUpgrade == false">无需升级</button>
                </div>
            </div>
            <div class="layui-card-body">
                <div class="layui-form">
                    <table class="layui-table">
                        <thead>
                        <tr>
                            <th>表名</th>
                            <th>说明</th>
                            <th>执行状态</th>
                            <th width="40%">错误原因</th>
                            <th>执行时间</th>
                            <th width="12%">操作</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr v-for="(item,index) in upgradeData">
                            <td>{{item.table}}</td>
                            <td>{{item.info}}</td>
                            <td>{{item.status ? '执行成功':'执行失败'}}</td>
                            <td>{{item.error}}</td>
                            <td>{{item.add_time}}</td>
                            <td>
                                <p v-if="!item.status">
                                    <button type="button" @click="reset(item,index)"
                                            class="layui-btn layui-btn-sm layui-btn-normal">重新执行
                                    </button>
                                    <button type="button" @click="startCopy(item)"
                                            class="layui-btn layui-btn-sm layui-btn-normal">复制sql
                                    </button>
                                </p>
                                <p v-else>无操作</p>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
                <div class="layui-form">

                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>
<script>
    var version = "<?=$version?>", isUpgrade = <?=$isUpgrade ? 'true' : 'false'?>, next = <?=$next?>,action = '<?=$action?>';
    new Vue({
        el: '#app',
        data: {
            version: version,
            sleep: 0,
            prefix: 'eb_',
            upgradeData: [],
            isUpgrade: isUpgrade,
            nextAction: false,
            action: action,
            nextA: next,
            executeIng:false,
            page:1,
        },
        methods: {
            next: function () {
                if (this.nextA == 1) {
                    location.href = 'index.php?a=product';
                } else if (this.nextA == 2) {
                    location.href = 'index.php?a=bargain';
                } else if (this.nextA == 3) {
                    location.href = 'index.php?a=pink';
                } else if (this.nextA == 4) {
                    location.href = 'index.php?a=coupon';
                } else if (this.nextA == 5) {
                    location.href = 'index.php?a=order';
                } else if (this.nextA == 6) {
                    location.href = 'index.php?a=recharge';
                } else if (this.nextA == 7) {
                    location.href = 'index.php?a=visit';
                }
            },
            requestPost: function (url, data) {
                return new Promise(function (resolve, reject) {
                    axios.post(url, data).then(function (res) {
                        if (res.status == 200 && res.data.code == 200) {
                            resolve(res.data)
                        } else {
                            reject(res.data);
                        }
                    }).catch(function (err) {
                        reject({msg: err})
                    });
                })
            },
            requestGet: function (url, data) {
                var params = Object.keys(data).map(function (key) {
                    return key + '=' + data[key];
                }).join('&');
                return new Promise(function (resolve, reject) {
                    axios.get(url + (params ? '?' + params : '')).then(function (res) {
                        if (res.status == 200 && res.data.code == 200) {
                            resolve(res.data)
                        } else {
                            reject(res.data);
                        }
                    }).catch(function (err) {
                        reject({msg: err})
                    });
                })
            },
            reset: function (item, index) {
                var that = this;
                this.requestGet('index.php', {
                    a: action,
                    sleep: index,
                    prefix: this.prefix,
                    alone: 1
                }).then(function (res) {
                    that.$set(that.upgradeData, index, res.data);
                    return that.showMsg(res.msg);
                })
            },
            startCopy: function (item) {
                var that = this;
                this.copy(item.sql).then(function () {
                    that.showMsg('复制成功');
                })
            },
            copy: function (attr) {
                return new Promise(function (resolve, reject) {
                    var target = document.createElement('div');
                    target.id = 'tempTarget';
                    target.style.opacity = '0';
                    target.innerText = attr;
                    document.body.appendChild(target);
                    try {
                        var range = document.createRange();
                        range.selectNode(target);
                        window.getSelection().removeAllRanges();
                        window.getSelection().addRange(range);
                        document.execCommand('copy');
                        window.getSelection().removeAllRanges();
                        resolve()
                    } catch (e) {
                        reject();
                    }
                    if (attr) {
                        // remove temp target
                        target.parentElement.removeChild(target);
                    }
                })
            },
            /**
             * 提示
             * */
            showMsg: function (msg, success) {
                layui.use(['layer'], function () {
                    layui.layer.msg(msg, success);
                });
            },
            /**
             * 开始升级
             */
            startUpgrade: function () {
                var that = this;
                if (!that.prefix) {
                    return that.showMsg('请填写表前缀');
                }

                this.requestGet('index.php', {
                    a: action,
                    sleep: this.sleep,
                    prefix: this.prefix,
                    page: this.page
                }).then(function (res) {
                    if (res.data.sleep !== -1) {
                        if (res.data.page) {
                            that.page = res.data.page;
                        }
                        that.sleep = res.data.sleep;
                        that.upgradeData.push(res.data);
                        that.executeIng = true;
                        setTimeout(function () {
                            that.startUpgrade();
                        }, 100);
                    } else {
                        that.isUpgrade = false;
                        that.nextAction = true;
                        that.executeIng = false;
                        return that.showMsg('执行完毕');
                    }
                }).catch(function (res) {
                    return that.showMsg(res.msg);
                });
            }
        },
        mounted: function () {
            layui.use('element', function () {

            });
        }
    });
</script>